<?php
ini_set('max_execution_time', 300); //300 seconds = 5 minutes
ini_set('memory_limit', '250M');
ini_set('short_open_tag', 1);
/**/
ini_set('error_reporting', E_ALL);
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);

$GLOBALS['settings_folder']=__DIR__.'/settings/';
$GLOBALS['temp_folder']=__DIR__.'/tempdata/';
@$GLOBALS['useragent']=file_get_contents($GLOBALS['temp_folder'].'useragent.txt');
$GLOBALS['cookie_file']=$GLOBALS['temp_folder'].'cookie.txt';
@$GLOBALS['pub_id']=file_get_contents($GLOBALS['temp_folder'].'pub_id.txt');
$GLOBALS['creative_review_req_string']='https://www.google.com/adsense/gp/creativeReview?ov=3&pid='.$GLOBALS['pub_id'].'&authuser=0&tpid='.$GLOBALS['pub_id'];
$GLOBALS['arc_tab_req_string']='https://www.google.com/adsense/new/u/0/'.$GLOBALS['pub_id'].'/main/allowAndBlockAds?webPropertyCode=ca-'.$GLOBALS['pub_id'].'&tab=arcTab';
$GLOBALS['myheaders']=array('accept-language:ru-RU,ru;q=0.8,en-US;q=0.6,en;q=0.4', 'content-type:application/javascript; charset=UTF-8');



if(!file_exists($GLOBALS['settings_folder'].'settings.ini') || !is_writeable($GLOBALS['settings_folder'].'settings.ini'))	{
    die('Check '.$GLOBALS['settings_folder'].' directory write permissions');
}

if(!is_writeable($GLOBALS['temp_folder']))	{
    die('Check '.$GLOBALS['temp_folder'].' directory write permissions');
}

//if(php_sapi_name()!='cli')
if(empty($argc))
if(file_exists($GLOBALS['temp_folder'].'pass'))
if(file_get_contents($GLOBALS['temp_folder'].'pass')!='')
if(!isset($_COOKIE['key'])||$_COOKIE['key']!=file_get_contents($GLOBALS['temp_folder'].'auth_key')) {  //Autentification if password not empty
	header("Location: auth.php");
	exit;
}







$set=file_get_contents($GLOBALS['settings_folder'].'settings.ini');
$set=json_decode($set, 1);

$GLOBALS['set_gl']=$set;

$nl='
';

/**
 **
**/


function is_data_safely($input_data) {
	$ret=true;
	if(strpos($input_data, "<?")!==false) $ret=false;
	if(strpos($input_data, "?>")!==false) $ret=false;
	if(strpos($input_data, "strtolower")!==false) $ret=false;
	if(strpos($input_data, "strtoupper")!==false) $ret=false;
	if(strpos($input_data, "{")!==false) $ret=false;
	if(strpos($input_data, "}")!==false) $ret=false;
	if(strpos($input_data, "$")!==false) $ret=false;
	if(strpos($input_data, "strip")!==false) $ret=false;
	if(strpos($input_data, "decode")!==false) $ret=false;
	if(strpos($input_data, "eval")!==false) $ret=false;
	if(strpos($input_data, "chr")!==false) $ret=false;
	return	$ret;
}



/**
 **
**/


function metagwt2array ($metahtml) {
	$dom = new DOMDocument;
	@$dom->loadHTML($metahtml);
	foreach ($dom->getElementsByTagName('meta') as $meta_node) {
		$list=explode('=', $meta_node->getAttribute('content'));
		$name=$list[0];
		$value=$list[1];
		unset($list);
		$name=str_replace('.', '_', $name);
		$gwtarray[$name]=$value;
	}
	unset($dom);
	return $gwtarray;
}


/**
 **
**/


function hex_repl($str) {
	$i=256;
	while($i>=0) {
		$hex=dechex($i);
		$str=str_ireplace("\x$hex", chr($i), $str);
		$i--;
	}
	return $str;
}


/**
 **
**/


function get_url_from_text_ad ($html) {

	$list=explode('buildAdSlot(', $html, 2);
	$script_with=$list[1];
		unset($list);
	$list=explode(');</script>', $script_with, 2);
	$script_with=$list[0];
		unset($list);
	$array=json_decode($script_with, 1);
		unset($script_with);
	$url=str_replace('\u0026', '&', $array[0][0][4]);
		unset($array);
	return $url;
}


/**
 **
**/


function get_2level_domain ($url) {
	$url=parse_url($url);

	$domain=explode('.', $url['host']);

	$last_index=count($domain)-1;

	$level2domain=$domain[$last_index-1].'.'.$domain[$last_index];
		unset($url,$domain,$last_index);
	return $level2domain;
}



/**
 **
**/


function count_redirects($url, $details) {

$domains[]=mb_strtolower( get_2level_domain($url) );

$myheaders = array('Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8',
'accept-language: ru-RU,ru;q=0.8,en-US;q=0.6,en;q=0.4',
'content-type: application/javascript; charset=UTF-8',
'Cache-Control: max-age=0',
'Connection: keep-alive',
'Host: '.$domains[0],);

$nl='
';

$result = curl_get($url, 'https://www.google.ru/', $myheaders);

$result=explode($nl, $result);

foreach ($result as $string) {
	if(stripos($string, 'Location')!==false)
		if(stripos($string, ': /')===false)		 //Some location headers do not include any domain names
		if(stripos($string, 'Content-Location')===false) {
			$url=str_ireplace('Location:', '', $string);
			$url=trim($url);
			$domains[]=mb_strtolower( get_2level_domain($url) );
	}
}

unset($result,$myheaders,$url);

$count=0;
foreach ($domains as $index => $domain) {
	if($index) {
		if($domains[$index-1]!=$domain)
			$count++;
	}
}
unset($domains);
return $count;
}


/**
 **
**/


function curl_post($url, $postfields, $referer, $myheaders) {

$ch = curl_init();
curl_setopt ($ch, CURLOPT_URL, $url);
curl_setopt ($ch, CURLOPT_POST, 1);
curl_setopt ($ch, CURLOPT_POSTFIELDS, $postfields);
curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt ($ch, CURLOPT_COOKIESESSION, 1);
curl_setopt ($ch, CURLOPT_HEADER, 0);
curl_setopt ($ch, CURLOPT_ENCODING, 'gzip,deflate');
if($myheaders) curl_setopt ($ch, CURLOPT_HTTPHEADER, $myheaders);
curl_setopt ($ch, CURLOPT_FOLLOWLOCATION, 1);
curl_setopt ($ch, CURLOPT_USERAGENT, $GLOBALS['useragent']);
curl_setopt ($ch, CURLOPT_COOKIEJAR, $GLOBALS['cookie_file']);
curl_setopt ($ch, CURLOPT_COOKIEFILE, $GLOBALS['cookie_file']);
curl_setopt ($ch, CURLOPT_REFERER, $referer);

$result = curl_exec($ch);
curl_close($ch);

unset($myheaders,$url,$postfields,$referer);

return $result;
}


/**
 **
**/


function curl_get($url, $referer, $myheaders) {

$ch = curl_init();
curl_setopt ($ch, CURLOPT_URL, $url);
curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt ($ch, CURLOPT_COOKIESESSION, 1);
curl_setopt ($ch, CURLOPT_HEADER, 0);
curl_setopt ($ch, CURLOPT_FOLLOWLOCATION, 1);
if($myheaders) curl_setopt ($ch, CURLOPT_HTTPHEADER, $myheaders);
curl_setopt ($ch, CURLOPT_ENCODING, 'gzip,deflate');
curl_setopt ($ch, CURLOPT_USERAGENT, $GLOBALS['useragent']);
curl_setopt ($ch, CURLOPT_COOKIEJAR, $GLOBALS['cookie_file']);
curl_setopt ($ch, CURLOPT_COOKIEFILE, $GLOBALS['cookie_file']);
if($referer) curl_setopt ($ch, CURLOPT_REFERER, $referer);
$result = curl_exec($ch);
curl_close($ch);

return $result;
}



/**
 **
**/




function get_ad ($url) {

$ad=curl_get($url, $GLOBALS['arc_tab_req_string'], '');
$ad=hex_repl($ad);

$list=explode('<html>', $ad, 2);
$ad_html=$list[1];
unset($list, $ad);

$dom = new DOMDocument;
@$dom->loadHTML($ad_html);
unset($ad_html);

foreach ($dom->getElementsByTagName('a') as $a_node) {
	if( stripos($a_node->getAttribute('class'), 'rhbackground')!==false ) $ad['fulltext']=iconv('UTF-8', 'ISO-8859-1', $a_node->textContent);
	$ad['fulltext']=mb_strtolower($ad['fulltext']);
	if( stripos($a_node->getAttribute('class'), 'rhtitleline1')!==false ) $ad['header1']=iconv('UTF-8', 'ISO-8859-1', $a_node->textContent);
	if( stripos($a_node->getAttribute('class'), 'rhtitleline2')!==false ) $ad['header2']=iconv('UTF-8', 'ISO-8859-1', $a_node->textContent);
	if( stripos($a_node->getAttribute('class'), 'rhbody')!==false ) $ad['body']=iconv('UTF-8', 'ISO-8859-1', $a_node->textContent);
	//Old ads (with just 1 header) support
	if( stripos($a_node->getAttribute('class'), 'rhtitle ')!==false || stripos($a_node->getAttribute('class'), 'rhtitle"')!==false ) $ad['header1']=iconv('UTF-8', 'ISO-8859-1', $a_node->textContent);
	if( stripos($a_node->getAttribute('class'), 'rhurl ')!==false || stripos($a_node->getAttribute('class'), 'rhurl"')!==false ) $ad['rhurl']=iconv('UTF-8', 'ISO-8859-1', $a_node->textContent);
}
unset($dom);

return $ad;
}



function get_stats ($ad_id) {

	$inner_params='[{"1":"'.$ad_id.'"}]';
	$params='{"1":'.$inner_params.'}';

	$result=creative_review ('getApprovalStats', $params);
	unset($inner_params, $params, $key);

	$result=$result->result->{1};
	$result=$result[0]->{3};
	$result=array_sum($result);
	return $result;
}




/**
 **
**/


function block_ad ($ad_id, $key, $unblock=0) {		// block and unblock function

	if($unblock) $mean_digit='0'; else $mean_digit='1';

	$inner_params='[{"1":{"1":"'.$ad_id.'"},"2":'.$mean_digit.'}]';  // parameter "2": 1 mean block, 0 mean unblock
	$params='{"1":'.$inner_params.',"2":"'.$key.'"}';

	$result=creative_review ('setCreativeDecisions', $params);
	unset($inner_params, $params, $key);
	return $result;
}


/**
 **
**/


function block_ad_account ($ad_id, $unblock=0) {		// block and unblock function

	if($unblock) $mean_digit='0'; else $mean_digit='1';

	$inner_params='[{"1":{"1":"'.$ad_id.'"},"2":'.$mean_digit.'}]';  // parameter "2": 1 mean block, 0 mean should unblock
	$params='{"2":'.$inner_params.'}';

	$result=creative_review ('setAdWordsAdvertiserDecisions', $params);
	unset($inner_params,$params);
	return $result;
}


/**
 **
**/


function list_ad ($ad, $ad_index, $found) {
$nl='
';
	if(isset($ad['header2']))			$header2='<br /><span>'.$ad['header2'].'</span>';
	else								$header2='';

	if(isset($ad['header1'])||$header2)	$header='<h2>'.$ad['header1'].$header2.'</h2>'.$nl;
	else								$header='';

	if(isset($ad['stopword']))			$stopword='<span class="stopword" >Blocked by: '.$ad['stopword'].'</span>';
	else								$stopword='';

	$url='<p><a href="http://nullrefer.com/?'.$ad['url'].'" target="_blank" rel="noreferrer" >'.$ad['rhurl'].'</a></p>'.$nl;

	$filename=time().'.'.$ad_index;

	$ad_id=rawurlencode($ad['ad_id']);
	$digikey=rawurlencode($ad['digikey']);

	if($found) {
		if($GLOBALS['set_gl']['get_stats']) $stats='<span class="stats" title="Total views">'.get_stats($ad['ad_id']).'</span>'; else $stats='';
	} else $stats='';

	$block='<a onclick="insert_result_frame(this);" href="blocker.php?type=ad&act=block&ad_id='.$ad_id.'&digikey='.$digikey.'" target="result_frame" class="block block_ad" title="Block this ad" ><img src="img/block.png" />Ad</a>
	<a onclick="insert_result_frame(this);" href="blocker.php?type=ad&act=unblock&ad_id='.$ad_id.'&digikey='.$digikey.'" target="result_frame" class="unblock unblock_ad" title="Unblock this ad" ><img src="img/unblock.png" />Ad</a> ';

	$block_account='<a onclick="insert_result_frame(this);" href="blocker.php?type=acc&act=block&ad_id='.$ad_id.'" target="result_frame" class="block block_acc" title="Block AdWords account" ><img src="img/block.png" />Acc</a>
	<a onclick="insert_result_frame(this);" href="blocker.php?type=acc&act=unblock&ad_id='.$ad_id.'" target="result_frame" class="unblock unblock_acc" title="Unblock AdWords account" ><img src="img/unblock.png" />Acc</a> ';


	$ad_header='<div class="ad_header"><span class="adv_id">'.$ad['adv_id'].'</span> '.$stopword.'</div>'.$nl;
	//title="'.$ad['fulltext'].'"
	$text='<div class="ad">'.$nl.$ad_header.$header.'<p>'.$ad['body'].'</p>'.$nl.$url.'</div><span class="block_buttons">'.$block.$block_account.$stats.'</span>'.$nl.$nl.$nl;


	if($found) {
		foreach($found as $index=>$value) {
			if($value) {
				file_put_contents($GLOBALS['temp_folder'].$index.'/'.$filename, $text, FILE_APPEND);
			}
		}
	} else
		file_put_contents($GLOBALS['temp_folder'].'clear/'.$filename, $text, FILE_APPEND);

return true;
}


/**
 **
**/


function mark_ads_reviewed ($ad_id) {

	foreach($ad_id as $id)
		$ids[]='{"1":"'.$id.'"}';
	unset($ad_id);

	$params='{"1":['.implode(',',$ids).']}';
	$result=creative_review ('setReviewedCreatives', $params);
	unset($params);

	return $result;
}


/**
 **
**/


function creative_review ($method, $params) {

	$xsrftoken=file_get_contents($GLOBALS['temp_folder'].'xsrftoken.txt');

	$creativeReview = new stdClass(); //to make json request string
	$creativeReview->method=$method;
	$creativeReview->params=$params;
	$creativeReview->xsrf=$xsrftoken;
	$creativeReview_post_request=json_encode($creativeReview);
	unset($creativeReview);

	$result=curl_post($GLOBALS['creative_review_req_string'], $creativeReview_post_request, $GLOBALS['arc_tab_req_string'], $GLOBALS['myheaders']);

/*	if(stripos($result, 'XSRF token validation')!==false) {
		file_put_contents($GLOBALS['temp_folder'].'creative_review/err.'.time(), $method.' /// '.$result, FILE_APPEND);
	}	*/																										//temp

	$result=json_decode($result);  // decode result string

	file_put_contents($GLOBALS['temp_folder'].'xsrftoken.txt', $result->xsrf); // Renew standard XSRF token

	return $result;
}


/**
 **
**/

function get_ad_list ($folder) {
if($folder=='blogspot'||$folder=='clear'||$folder=='redirect'||$folder=='word') {
	$ad_files=scandir($GLOBALS['temp_folder'].$folder);
	unset($ad_files[0],$ad_files[1]);	//removes . and ..

	$ads_text='';
	foreach($ad_files as $ad_file) {

		$time=explode('.',$ad_file);
		$time='<span title="When was checked" class="date_time">'.date("d.m.Y", $time[0]).'<br>'.date("H:i:s", $time[0]).'</span>';
		$trash='<a title="Delete this ad" class="trash" onclick="close_ad(this);" href="delete.php?folder='.$folder.'&ad_file='.rawurlencode($ad_file).'" target="working_frame"><img src="img/trash.gif" /></a>';
		$ads_text.='<div class="ad_container" >'.file_get_contents($GLOBALS['temp_folder'].$folder.'/'.$ad_file).$time.$trash.'</div>';
	}

return $ads_text;
}
}


/**
 **
**/


function remove_ad_files ($folder, $ad_file) {
if($folder=='blogspot'||$folder=='clear'||$folder=='redirect'||$folder=='word') {
	if($ad_file){
		$result=unlink ($GLOBALS['temp_folder'].$folder.'/'.$ad_file);
	}
	else {
		$ad_files=scandir($GLOBALS['temp_folder'].$folder);
		unset($ad_files[0],$ad_files[1]);	//removes . and ..
		foreach($ad_files as $ad_file) {
			$result=unlink ($GLOBALS['temp_folder'].$folder.'/'.$ad_file);
			if(!$result) $break;
		}
	}

return $result;
}
}


?>

