<?php
$start_time=time();
include 'functions.php';

$first_result=curl_get($GLOBALS['arc_tab_req_string'], '', '');

if(isset($set['log'])) file_put_contents($GLOBALS['temp_folder'].'logs/s1'.time(), $first_result);

unset($first_result);

/**
 * Get first access tokens:
**/

$url='https://www.google.com/adsense/gwt-properties?pid='.$GLOBALS['pub_id'].'&authuser=0&tpid='.$GLOBALS['pub_id'].'&ov=3';
$result=curl_post($url, '', $GLOBALS['arc_tab_req_string'], $GLOBALS['myheaders']); // Requesting access tokens in meta tags

if(isset($set['log'])) file_put_contents($GLOBALS['temp_folder'].'logs/s2_gwt'.time(), $result);

$gwtarray=metagwt2array($result); // Converting data to array
file_put_contents($GLOBALS['temp_folder'].'xsrftoken.txt', $gwtarray['syn_token_pb']); // Put XSRF new token



/**
 * Get temporary access tokens:
**/

if(isset($_GET['start'])) {
	if(is_data_safely($_GET['start'])) 
		$start_pos=(int)$_GET['start'];
}
else
	$start_pos=0;

if(isset($set['badadlist_check']))
	if(file_exists($GLOBALS['temp_folder'].'bad_ads_text')){
		$badadlistwords=file($GLOBALS['temp_folder'].'bad_ads_text', FILE_IGNORE_NEW_LINES);
	}

if(isset($set['stopwords_check'])) {
	$stopwords=file($GLOBALS['settings_folder'].'stopwords.txt', FILE_IGNORE_NEW_LINES);
	if(isset($badadlistwords))
		if(is_array($badadlistwords))
			foreach($badadlistwords as $badadlistword)
				$stopwords[]=$badadlistword;
}


$checked=0;
$blocked=0; //Coount of blocked ads

for($i=0;$i<$set['num_of_pages'];$i++) {

	$params = new stdClass();
	@$params->{1}='ca-'.$GLOBALS['pub_id'];
	$params=json_encode($params);

	$result=creative_review('getWebPropertyMetricsToken', $params);

	unset($params);

	if(isset($set['log'])) file_put_contents($GLOBALS['temp_folder'].'logs/s3_1st_tok'.time(), $result);


	/**
	 * Get ads list:
	**/

	$some_long_token=$result->result->{1}->{1}->{1}; // some auth token...

	if(isset($set['text'])) $type['text']='0';
	if(isset($set['rich_media'])) $type['media']='2';
	$media_types='['.implode(',',$type).']';

		$params = new stdClass();
		@$params->{1}='ca-'.$GLOBALS['pub_id'];  // Publisher Id ca-pub-...
			if(isset($set['reviewed']))					@$params->{2}->{1}=$start_pos+($i*$set['num_of_ads_per_page']);		// Start position
			else if(!isset($set['mark_reviewed']))		@$params->{2}->{1}=$start_pos+($i*$set['num_of_ads_per_page']);		// Start position
			else 										@$params->{2}->{1}=0;		// Start position
			@$params->{2}->{2}=$set['num_of_ads_per_page'];	// Ads qty
			@$params->{2}->{3}=0;							// 0 - Shown ads; 1 - already blocked ads
			@$params->{2}->{4}->{1}->{1}=$some_long_token;
			if(!isset($set['reviewed'])) @$params->{2}->{5}->{2}=1;		//Reviewed ads
			if(isset($set['predicted'])) @$params->{2}->{5}->{3}=1;		//Predicted block
			@$params->{2}->{5}->{16}=$media_types;			// 0 - Text; 1 - graphics; 2 - Media; If checked all types the parameter is absent.
			if(!isset($set['rich_media'])) @$params->{2}->{5}->{17}=0;			//Disappears at turning on media type
		//$params->{3}='-6928690776790362';						// It seems we and Google do not need it
		$params=json_encode($params);
		$params=str_replace('"[', '[', $params);
		$params=str_replace(']"', ']', $params);

	$result=creative_review('searchArcApprovals', $params);

	if(isset($set['log'])) file_put_contents($GLOBALS['temp_folder'].'logs/s4_ads_list'.time(), $result);


	if(@$result->result->{8}==='0') { 	//If no ads at server response then stop ads loading
		echo 'No ads left<br />';
		break;
	}

	$digikey_for_req=$result->result->{5}; // Some digits required to control requests.

	foreach($result->result->{1} as $key=>$node) {
		$ad_req_urls=$node->{5}->{10}; // url we can access ad sourse code
		$ad[$key]=get_ad($ad_req_urls);	//Indexes of returned array: fulltext, header1, header2, body
		$ad[$key]['adv_id']=$node->{5}->{17}.' '.$node->{5}->{20}; // advertiser name and id
		$ad[$key]['url']=$node->{5}->{14};
		$ad[$key]['url_displayed']=$node->{5}->{15};
		$ad_id[]=$ad[$key]['ad_id']=$node->{4}->{1}; // Some sequence required to control requests of each ad
		$ad[$key]['digikey']=$digikey_for_req;
		$ad[$key]['src_link']=$node->{5}->{10}; // url we can access ad sourse code
		set_time_limit(30);		//Renew time limit for each ad download
	}

	unset($result,$ad_req_urls);

	foreach($ad as $index=>$adunit) {

		$found['word']=0;
		if(isset($set['stopwords_check'])||isset($set['badadlist_check'])) {	
			foreach($stopwords as $stopword) {
				if(mb_stripos($adunit['fulltext'], $stopword)!==false) {		//if we can find any bad word
					$found['word']=1;
					$adunit['stopword']=$stopword;
					break;
					
				}
			}
		}

		$found['redirect']=0;
		if(isset($set['redirects'])) {
			if(count_redirects($adunit['url'], 1))	{							//if we can find any another domain redirect
				$found['redirect']=1;
			}
		}

		$found['blogspot']=0;
		if(isset($set['blogspot'])) {
			if(stripos($adunit['url'], 'blogspot.com')!==false) 		//if we can find blogspot.com
				$found['blogspot']=1;
		}
		
		if($found['word']||$found['redirect']||$found['blogspot']) {
			block_ad($ad_id[$index], $digikey_for_req, 0);
			if(isset($set['ad_account']))	block_ad_account($ad_id[$index], 0);
			list_ad($adunit, $index, $found);
			$blocked++;
		} else {
			if(!isset($set['no_save_clear']))	list_ad($adunit, $index, 0);
		}
		$checked++;

	}

	if(isset($set['mark_reviewed'])) mark_ads_reviewed ($ad_id);
	unset($ad,$ad_id);
}



$exe_time=time()-$start_time;
$exe_time=date("i:s", $exe_time);

echo "Execution time: $exe_time.<br />
Checked: $checked.<br />
Blocked: $blocked.";


?>







